<?php

class email {

    function email () {
		if(!defined('EMAIL_CRLF')) {
  			if (strtoupper(substr(PHP_OS, 0, 3) == 'WIN')) {
    			define('EMAIL_CRLF', "\r\n");
  			} elseif (strtoupper(substr(PHP_OS, 0, 3) == 'MAC')) {
    			define('EMAIL_CRLF', "\r");
  			} else {
    			define('EMAIL_CRLF', "\n");
  			}
		}
    }
	
    function sendEmail($toAddress, $subject, $message, $sendername = null, $senderemail = null, $cc = null, $bcc = null) {
  		$toAddress = preg_replace("/\r/", "", $toAddress);
  		$toAddress = preg_replace("/\n/", "", $toAddress);
  		if(isset($senderemail)) {
			$senderemail = preg_replace("/\r/", "", $senderemail);
    		$senderemail = preg_replace("/\n/", "", $senderemail);
  		}
  		$replyname  = isset($sendername)  && !empty($sendername) ? $sendername : $mainsettings['websitetitle'];
  		$replyemail = isset($senderemail) && !empty($senderemail) ? $senderemail : $mainsettings['technicalemail'];
  		$fromemail  = isset($senderemail) && !empty($senderemail) && ($mainsettings['techfromemail'] == 0) ? $senderemail : $mainsettings['technicalemail'];
  		$languageinfo = explode('|', $mainsettings['language']);
  		$headers  = "MIME-Version: 1.0" . EMAIL_CRLF;
  		$headers .= "Content-type: text/plain; charset=windows-1251" . EMAIL_CRLF;
  		if (strtoupper(substr(PHP_OS,0,3)=='WIN')) {
    		$headers .= "From: \"" . $fromemail . "\"" . EMAIL_CRLF;
    		$headers .= "Reply-To: \"$replyemail\"" . EMAIL_CRLF; 
		} else {
    		$headers .= "From: \"" . $replyname . "\" <" . $fromemail . ">" . EMAIL_CRLF;
    		$headers .= "Reply-To: \"$replyname\" <$replyemail>" . EMAIL_CRLF;
  		}
  		if(isset($cc)) {
    		$headers .= "cc: $cc" . EMAIL_CRLF;
  		}
  		if(isset($bcc)) {
    		$headers .= "Bcc: $bcc" . EMAIL_CRLF;
  		}
  		$headers .= "X-Mailer: PHP v" . phpversion() . EMAIL_CRLF; // This can help avoid spam-filters
  		$subject = strip_tags($this->unhtmlspecialchars($subject));
  		$message = strip_tags($this->unhtmlspecialchars($message));
  		return @mail($toAddress, $subject, $message, $headers);
	}

	function sendEmailAttachment($toAddress, $subject, $message, $attachment, $filename, $MIMEType = null, $sendername = null, $senderemail = null, $cc = null, $bcc = null) {
  		$toAddress = preg_replace("/\r/", "", $toAddress);
  		$toAddress = preg_replace("/\n/", "", $toAddress);
  		if(isset($senderemail)) {
    		$senderemail = preg_replace("/\r/", "", $senderemail);
    		$senderemail = preg_replace("/\n/", "", $senderemail);
  		}
  		$languageinfo = explode('|', $mainsettings['language']);
  		$boundary   = uniqid("");
  		$MIMEType =  (isset($MIMEType) && !empty($MIMEType)) ? $MIMEType : 'application/unknown';
  		$attachment = base64_encode($attachment);
  		$attachment = chunk_split($attachment);
  		$replyname  = isset($sendername) && !empty($sendername) ? $sendername : $mainsettings['websitetitle'];
  		$replyemail = isset($senderemail) && !empty($senderemail) ? $senderemail : $mainsettings['technicalemail'];
  		$fromemail  = isset($senderemail) && !empty($senderemail) && ($mainsettings['techfromemail'] == 0) ? $senderemail : $mainsettings['technicalemail'];
  		$headers  = "MIME-Version: 1.0" . EMAIL_CRLF;
  		if (strtoupper(substr(PHP_OS,0,3)=='WIN')) {
    		$headers .= "From: \"" . $fromemail . "\"" . EMAIL_CRLF;
    		$headers .= "Reply-To: \"$replyemail\"" . EMAIL_CRLF;
  		} else {
    		$headers .= "From: \"" . $replyname . "\" <" . $fromemail . ">" . EMAIL_CRLF;
    		$headers .= "Reply-To: \"$replyname\" <$replyemail>" . EMAIL_CRLF;
  		}
  		if(isset($cc)) {
    		$headers .= "cc: $sendto" . EMAIL_CRLF;
  		}
  		if(isset($bcc)) {
    		$headers .= "Bcc: $sendto" . EMAIL_CRLF;
  		}
  		$headers .= "Content-type: multipart/mixed; boundary=\"$boundary\"" . EMAIL_CRLF;
  		$headers .= "X-Mailer: PHP v" . phpversion() . EMAIL_CRLF;          // This can help avoid spam-filters
  		$message = stripslashes($message);
  		$subject = strip_tags($this->unhtmlspecialchars($subject));
  		$message = strip_tags($this->unhtmlspecialchars($message));
  		$msgbody  = "--$boundary" . EMAIL_CRLF;
  		$msgbody .= "Content-type: text/plain; charset=windows-1251" . EMAIL_CRLF;
  		$msgbody .= "Content-transfer-encoding: 8bit" . EMAIL_CRLF;
  		$msgbody .= EMAIL_CRLF;
  		$msgbody .= "$message" . EMAIL_CRLF;
  		$msgbody .= "--$boundary" . EMAIL_CRLF;
  		$msgbody .= "Content-type: $MIMEType; name=$filename" . EMAIL_CRLF;
  		$msgbody .= "Content-disposition: attachment; filename=$filename" . EMAIL_CRLF;
  		$msgbody .= "Content-transfer-encoding: base64" . EMAIL_CRLF;
  		$msgbody .= EMAIL_CRLF;
  		$msgbody .= "$attachment" . EMAIL_CRLF;
  		$msgbody .= EMAIL_CRLF;
  		$msgbody .= "--$boundary--" . EMAIL_CRLF;
  		return @mail($toAddress, $subject, $msgbody, $headers);
	}
	
	private function unhtmlspecialchars($string) {
  		$trans = get_html_translation_table(HTML_ENTITIES);
  		$string = str_replace('&#39;', '&#039;', $string);
  		$string = str_replace('&#33;', '&#033;', $string);
  		$trans["'"] = '&#039;';
  		$trans[""] = '&ldquo;';
  		$trans[""] = '&rdquo;';
  		$trans[""] = '&lsquo;';
  		$trans[""] = '&rsquo;';
  		$trans[""] = '&laquo;';
  		$trans[""] = '&raquo;';
  		$trans[""] = '&copy;';
  		$trans[""] = '&reg;';
  		$trans[""] = '&trade;';
  		$trans["!"] = '&#033;';
  		$trans["$"] = '&#036;';
  		$trans = array_flip ($trans);
  		return strtr($string, $trans);
	}
	
}
?>